/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package semestralka;

import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.InetAddress;
import java.net.Socket;
import java.util.logging.Logger;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 *
 * @author Radek Hubner
 */
public class KarelClient {

    private Logger log = Logger.getLogger(this.getClass().getName());
    private Integer baterie = null;
    public static final int OK_250 = 250;
    public static final int PORUCHA_570 = 570;
    public static final int ZNACKA_OK = 221;
    Socket sok = null;
    String osloveni = null;
    FuckingBufferedReader in = null;
    PrintWriter out = null;

    public KarelClient(InetAddress adresa, int port) throws IOException {
        sok = new Socket(adresa, port);
        in = new FuckingBufferedReader(new InputStreamReader(sok.getInputStream()));
        out = new PrintWriter(sok.getOutputStream());
        ctiOsloveni();  //precte osloveni
    }

    private void ctiOsloveni() {
        //TODO opravit chybne a rekruzivni detekce
        Pattern p = Pattern.compile("^220 Oslovuj mne ([^\\.]{1,512})\\..*");
        String s = in.readLine();
        Matcher m = p.matcher(s);
        if (m.matches()) {
            osloveni = m.group(1);
            log.info("osloveni : " + osloveni);
        } else {
            throw new IllegalArgumentException("Spatne osloveni od robota");
        }
    }

    private Robot _krok() {
        out.write(osloveni + " KROK");
        zapisKonecRadku();
        out.flush();

        Odpoved o = ctiOdpoved();
        switch (o.getKod()) {
            case OK_250:
                return new Robot(o);
            case PORUCHA_570:
                o = oprav(getBlok(o.getMsg()));
                if (o.getKod() != OK_250) {
                    throw new IllegalArgumentException("oprava chybneho bloku");
                } else {
                    return new Robot(o);
                }
            default:
                throw new DalsiChyba("chyba pri kroku", o);
        }
    }

    private Robot _vlevo() {
        String zapsano = osloveni + " VLEVO";
        log.info("zapsano : " + zapsano);
        out.write(zapsano);
        zapisKonecRadku();
        out.flush();
        Odpoved o = ctiOdpoved();

        if (o.getKod() == OK_250) {
            return new Robot(o);
        } else {
            throw new DalsiChyba("chyba pri nabijeni", o);
        }
    }

    private Robot nabit() {
        out.write(osloveni + " NABIT");
        zapisKonecRadku();
        out.flush();
        Odpoved o = ctiOdpoved();

        switch (o.getKod()) {
            case OK_250:
                return new Robot(o);
            case PORUCHA_570:
                o = oprav(getBlok(o.getMsg()));
                if (o.getKod() != OK_250) {
                    throw new IllegalArgumentException("oprava chybneho bloku");
                } else {
                    return new Robot(o);
                }
            default:
                throw new DalsiChyba("chyba pri nabijeni", o);
        }
    }

    public String zvedni() {
        out.write(osloveni + " ZVEDNI");
        zapisKonecRadku();
        out.flush();
        Odpoved o = ctiOdpoved();        
        if (o.getKod() == ZNACKA_OK) {
            return o.getMsg();
        } else {
            throw new DalsiChyba("chyba pri zvednuti znacky", o);
        }
    }

    private Odpoved oprav(int blok) {
        out.write(osloveni + " OPRAVIT " + blok);
        zapisKonecRadku();
        out.flush();
        Odpoved o = ctiOdpoved();
        return o;
    }

    private Odpoved ctiOdpoved() {
        String s = in.readLine();
        return new Odpoved(s);
    }

    private int getBlok(String msg) {
        Pattern p = Pattern.compile("^PORUCHA BLOK (\\d)", Pattern.CASE_INSENSITIVE);
        Matcher m = p.matcher(msg);
        if (m.matches()) {
            return Integer.valueOf(m.group(1));
        } else {
            throw new IllegalArgumentException("chybna odpoved na chybu");
        }
    }

    private void zapisKonecRadku() {
        out.write(0x0D);
        out.write(0x0A);
    }

    public void close()  {
        try {
        out.close();
        in.close();
        sok.close();
        }catch(Exception ex) {
            ex.printStackTrace();
        }
    }

    /**
     * Provede krok a zaroven se stara o stav baterie.
     * Nestara se o to zdali se krok provede.
     * @return
     */
    public Robot krok() {
        while (baterie != null && baterie < 20) {
            Robot r = nabit();
            baterie = r.getBaterie();
        }
        Robot r = _krok();
        baterie = r.getBaterie();
        log.info(r.toString());
        return r;
    }

    /**
     * Provede krok a pokud je zadan parametr tak se postara i o to aby se krok provedl.
     * Pripadne ho zopakuje dokud robot neudela krok.
     * @param r1
     * @return
     */
    public Robot krok(Robot r1) {
        Robot r2 = null;
        do {
            r2 = krok();
        }while(r2.equals(r1));
        return r2;        
    }

    public Robot vlevo() {
        while (baterie != null && baterie < 20) {
            Robot r = nabit();
            baterie = r.getBaterie();
        }
        Robot r = _vlevo();
        baterie = r.getBaterie();
        log.info(r.toString());
        return r;
    }

    public Robot vpravo() {
        vlevo();
        vlevo();
        return vlevo();
    }
}
